<template>
  <div
    data-component-group="users-form"
    data-component="category-limits"
  >
    <div
      v-if="!isDisabled"
      class="component-header"
    >
      <v-flex xs12>
        <v-layout>
          <v-flex xs6>
            <v-autocomplete
              v-model="selectedCategories"
              :items="categories"
              :filter="customFilter"
              :multiple="true"
              prepend-inner-icon="public"
              label="Categories"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              :readonly="isDisabled"
              :menu-props="{nudgeBottom:'10'}"
              :error-messages="categoryErrors"
              @blur="$v.selectedCategories.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <v-autocomplete
              v-model="selectedCountry"
              :items="countries"
              :filter="customFilter"
              prepend-inner-icon="public"
              label="Country"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              :readonly="isDisabled"
              :menu-props="{nudgeBottom:'10'}"
              :error-messages="countryErrors"
              @blur="$v.selectedCountry.$touch()"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <div class="component-actions">
        <v-btn
          color="primary"
          depressed
          @click="onUpdate"
        >
          <v-icon>
            {{ triggerIcon }}
          </v-icon>
          {{ triggerLabel }}
        </v-btn>
      </div>
    </div>
    <div class="component-body">
      <Removables
        v-if="hasItems"
        :items="limits"
        :is-disabled="isDisabled"
        :on-remove="onRemove"
      >
        <template
          slot="item"
          slot-scope="scope"
        >
          <v-flex
            xs12
            class="item-grid"
          >
            <v-layout>
              <v-flex xs6>
                <AmountLabel
                  label="Category"
                  size="lg"
                  :value="scope.item.categories.map(({ name }) => name).join(', ')"
                />
              </v-flex>
              <v-flex xs6>
                <AmountLabel
                  label="Country"
                  size="lg"
                  :value="scope.item.country.name"
                />
              </v-flex>
            </v-layout>
          </v-flex>
        </template>
      </Removables>
    </div>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Removables from '../../lists/Removables';
  import AmountLabel from '../../labels/Amount';
  import { isStr } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      Removables,
      AmountLabel
    },
    mixins: [validationMixin],
    validations() {
      return {
        selectedCategories: {
          required
        },
        selectedCountry: {
          required
        }
      };
    },
    props: {
      limits: {
        type: Array,
        default() {
          return [];
        }
      },
      triggerIcon: {
        type: String,
        default: 'add'
      },
      triggerLabel: {
        type: String,
        default: 'Add'
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      onSubmit: {
        type: Function,
        default: () => {}
      },
      onRemove: {
        type: Function,
        default: () => {}
      }
    },
    data() {
      return {
        selectedCategories: [],
        selectedCountry: {},
        colors
      };
    },
    computed: {
      country() {
        return this.$store.getters['config/country'];
      },
      countries() {
        return this.$store.getters['users/countries'];
      },
      hasItems() {
        return this.limits.length > 0;
      },
      categories() {
        return this.$store.getters['threads/categories'];
      },
      categoryErrors() {
        const errors = [];
        if (!this.$v.selectedCategories.$dirty) {
          return errors;
        }
        if (!this.$v.selectedCategories.required) {
          errors.push('Category is required');
        }
        return errors;
      },
      countryErrors() {
        const errors = [];
        if (!this.$v.selectedCountry.$dirty) {
          return errors;
        }
        if (!this.$v.selectedCountry.required) {
          errors.push('Country is required');
        }
        return errors;
      }
    },
    created() {
      this.getCategories();
    },
    methods: {
      getCategories() {
        const query = {
          target_country: this.country.code
        };

        return this.$store.dispatch('threads/getCategories', query);
      },
      onUpdate() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }

        const { selectedCategories, selectedCountry, onSubmit } = this;

        onSubmit({
          categories: selectedCategories,
          country: selectedCountry
        });

        this.clear();
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      canSubmitRequest() {
        const { categories, selectedCountry } = this;

        return isStr(selectedCountry.code)
          && categories.length > 0;
      },
      clear() {
        this.$v.$reset();
        this.selectedCategories = [];
        this.selectedCountry = {};
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="users-form"] {
    &[data-component="category-limits"] {
      padding: 0 0 10px 0;

      .component-actions {
        text-align: right;

        .v-btn {
          border-radius: 4px;
          margin-right: 0;

          .v-icon {
            margin: 0 6px 0 0;
          }
        }
      }

      .labels {
        display: flex;
        justify-content: flex-start;
        align-items: center;
        flex-wrap: wrap;
      }

      .label {
        display: flex;
        justify-content: flex-start;
        align-items: center;
        font-size: 14px;
        padding: 2px 6px;
        margin: 0 10px 10px 0;
        border-radius: 4px;
        color: $colors.shades.white;
        background-color: $colors.primary;

        .v-icon {
          font-size: 16px;
          margin: 0 6px 0 0;
          color: $colors.shades.white;
        }
      }

      .item-grid {
        width: 100%;

        .layout {
          align-items: center;
          height: 100%;
          margin: 0;
        }
      }
    }
  }
</style>
